/*****************************************************************************
*                                                                            *
* void      Ausschnitt()                                                     *
*                                                                            *
******************************************************************************
*                                                                            *
* Extrahiert einen Ausschnitt aus einem Bild                                 *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 09.10.1992                                               *
* Letzte Aenderung: 10.10.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Ausschnitt()
{
  int  BildNr1, BildNr2;           /* Nummer von Quell- und Zielbild        */
  long z, s;                       /* Zeilen- und Spaltenzaehler            */
  long Index1, Index2;             /* Adresse der beiden Bilder             */
  long Z_Res_Pic, S_Res_Pic;       /* Aufloesung des Quellbildes            */
  long S_Zeilen, S_Spalten;        /* Zeilen-/Spalten-Offset beim Quellbild */
  long Breite, Hoehe;              /* Groesse des Bildausschnittes          */


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Ausschnitt bilden *");

  gotoxy(35,20);
  BildNr1=Read_Int("Quell-Bild ", 1, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  gotoxy(35,21);
  BildNr2=Read_Int("Ziel-Bild  ", 2, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */

  Index1 = (long) (BildNr1) * PIC_SIZE;  /* Adresse der beiden Bilder ber.  */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  Z_Res_Pic = Bild[BildNr1].Zeilen;      /* Aufloesung des Quellbildes      */
  S_Res_Pic = Bild[BildNr1].Spalten;

  do {
     gotoxy(35,22);
     S_Spalten  = Read_Int("Linke Spalte ", INT_NO_DEFAULT, ':' );
  } while ((S_Spalten < 0) || (S_Spalten > S_Res_Pic));
  do {
     gotoxy(35,23);
     S_Zeilen  = Read_Int("Obere Zeile  ", INT_NO_DEFAULT, ':' );
  } while ((S_Zeilen < 0) || (S_Zeilen > Z_Res_Pic));

  do {
     gotoxy(35,24);
     Breite = Read_Int( "Breite      ", INT_NO_DEFAULT, ':' );
  } while ((Breite < 0) || ((Breite+S_Spalten) > S_Res_Pic));
  do {
     gotoxy(35,25);
     Hoehe  = Read_Int( "Hoehe       ", INT_NO_DEFAULT, ':' );
  } while ((Hoehe < 0) || ((Hoehe+S_Zeilen) > Z_Res_Pic));

  /* Ziel-Bild zuerst komplett loeschen.                                    */
  for (s=0; s<PIC_SIZE; s++) Pictures[Index2+s]=SCHWARZ;

  /* Ausschnitt aus dem Quellbild in das Zielbild ab (0,0) kopieren         */
  for (z=0; z<Hoehe; z++)
      for (s=0; s<Breite; s++)
          Pictures[Index2+z*Breite+s] =
                  Pictures[Index1+(z+S_Zeilen)*S_Res_Pic+s+S_Spalten];

  /* Bildinformation komplett erstellen                                     */
  Bild[BildNr2].Zeilen =Hoehe;
  Bild[BildNr2].Spalten=Breite;
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =FALSE;

  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);

}
