/*****************************************************************************
*                                                                            *
* void      Binaerbild(int BildNr, int Schwelle)                             *
*                                                                            *
******************************************************************************
*                                                                            *
* Erzeugt ein Binaerbild aufgrund der angegebenen Schwelle.                  *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 10.10.1992                                               *
* Letzte Aenderung: 10.10.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input:  BildNr = Nummer des Ausgangs-/Zielbildes (1<=BildNr<=MAX_PICTURE)  *
*         Schwelle = Schwelle fuer Binaerbild                                *
*                    Pixel < Schwelle: Pixel=SCHWARZ                         *
*                    Pixel >=Schwelle: Pixel=WEISS                           *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Binaerbild(int BildNr, int Schwelle)
{
  long z;                                    /* Index ueber die Bildgroesse */
  long Index;                                /* Bild-Anfangsadresse         */

  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Binaerbild erzeugen *");

  if (BildNr == FALSE) {
     gotoxy(35,20);
     BildNr=Read_Int("Bild Nr. ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben? Ist dieses Bild ueberhaupt benutzt?   */
  if ((BildNr<=0) || (BildNr>MAX_PICTURE)) return;
  BildNr--;                           /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr].Used) return;

  Index = (long) (BildNr) * PIC_SIZE; /* Anfangsadresse des Bildes          */
  for (z=0; z<PIC_SIZE; z++) {
      Pictures[Index]=(Pictures[Index]<Schwelle) ? SCHWARZ:WEISS;
      Index++;
  }

}
