/*****************************************************************************
*                                                                            *
* void Erosion(int BildNr1, int BildNr2, int Schwelle)                       *
*                                                                            *
******************************************************************************
*                                                                            *
* Fuehrt eine Erosion auf einem Binaerbild durch.                            *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 25.02.1993                                               *
* Letzte Aenderung: 25.02.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input: BildNr1 = Quellbild                                                 *
*        BildNr2 = Zielbild                                                  *
*        Schwelle= Schwelle fuer die Erosion                                 *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(), Geduld(),          *
*             Make_Icon(), Show_Pic()                                        *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Erosion(int BildNr1, int BildNr2, int Schwelle)
{
  long  z, s, Z_Temp, S_Temp;     /* Variablen fuer Zeilen und Spaltenindex */
  long  Index1, Index2, Index;    /* Adresse der drei Bilder                */
  int   i, j, zwerg;              /* Fenstergroesse und Zwischenergebnis    */
  long  Zmax, Smax;               /* Bildgroesse                            */


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Erosion 3x3 *");

  if (!BildNr1) {
     gotoxy(35,20);
     BildNr1=Read_Int("Quell-Bild            ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  if (!BildNr2) {
     gotoxy(35,21);
     BildNr2=Read_Int("Erosions-Bild         ", 2, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */


  while ((Schwelle<1) || (Schwelle>9)) {
     gotoxy(35,22);
     Schwelle=Read_Int("Erosionsschwelle (-9) ", 9, ':');
  }

  Index1 = (long) (BildNr1) * PIC_SIZE; /* Adresse der beiden Bilder        */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  Zmax = Bild[BildNr1].Zeilen;     /* Groesse des zu bearbeitenden Bildes   */
  Smax = Bild[BildNr1].Spalten;

  Geduld();                        /* Da es lange dauert eine kurze Meldung */

  for (z=0; z<Zmax; z++) {
      for (s=0; s<Smax; s++) {
          zwerg=0;                 /* Summe der Grauwerte im Fenster        */
          for (i= -1; i<=1; i++) {                   /* Filtergroesse Zeile */
              Z_Temp=z+i;
              if (Z_Temp<0) Z_Temp= -Z_Temp-1;       /* Klipping am Rand!   */
              else if (Z_Temp>=Zmax) Z_Temp=z-i+1;
              Z_Temp=Z_Temp*Smax;
              for (j= -1; j<=1; j++) {               /* Filtergroesse Spalte*/
                  S_Temp=s+j;
                  if (S_Temp<0) S_Temp= -S_Temp-1;   /* Klipping am Rand!   */
                  else if (S_Temp>=Smax) S_Temp=s-j+1;
                  Index=Index1+Z_Temp+S_Temp;
                  if (Pictures[Index]>0) zwerg++;    /* Werte aufsummieren..*/
              }
          }
          if (zwerg<Schwelle) Pictures[Index2++]=SCHWARZ;
          else                Pictures[Index2++]=WEISS;
      }
  }

  /* Bildinformation zum Schluss korrekt setzen und ...                     */
  Bild[BildNr2].Zeilen =Zmax;
  Bild[BildNr2].Spalten=Smax;
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =FALSE;

  /* ... Ergebnisbild anzeigen.                                             */
  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);
}
