/*****************************************************************************
*                                                                            *
* void Histo_darst(int BildNr, int Anzahl, float Histogramm_Werte[S_RES_MAX],*
*                  int Shift)                                                *
*                                                                            *
******************************************************************************
*                                                                            *
* Zeigt ein Histogramm mit float-Werten normiert im normalen Wertebereich an.*
*                                                                            *
******************************************************************************
*                                                                            *
*  Input:     BildNr = Nummer des Bildes in dem das Histogramm ausgegeben    * *
*             Anzahl = Anzahl der verwendeten Histogramm_Werte               *
*             Histogramm_Werte[] = Vektor mit Werten                         *
*             Shift  = Offset fuer ggf. notwendigen zyklische Verschiebung   *
*                      der Histogrammwerte zur "gewohnten" Darstellung       *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 13.12.1992                                               *
* Letzte Aenderung: 21.04.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: Make_Icon(),                                                   *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Histo_darst(int BildNr, int Anzahl, float Histogramm_Werte[S_RES_MAX], int Shift)
{
  long i,j;              /* Laufvariablen                                   */
  int begin,ende;        /* Startpunkt / Endpunkt fuer den Zwischenraum     */
  float max,min;         /* Maximum und Minimum der Histogramm_Werte[]      */
  long Index;

  Index = (long) (BildNr) * PIC_SIZE;    /* Adresse des Ausgabebildes       */
  for (i=0; i<PIC_SIZE; i++) Pictures[Index+i]=SCHWARZ;
  min =  100000.0;
  max = -100000.0;

  /* Berechnung von Maximum und Minimum der Histogramm_Werte                */
  for (i=0; i<Anzahl; i++) {
      if (Histogramm_Werte[i]>max) max=Histogramm_Werte[i];
      if (Histogramm_Werte[i]<min) min=Histogramm_Werte[i];
  }

  if (min>0.0) min=0.0;   /* "Downbalken" nur bei negativen Werten zeichnen */
  max=max-min;

  if (max<EPS_ERROR) return; /* Falls keine vernuenftigen Werte ---> Abbruch*/

  /* Berechnung eines Balkendiagramms skaliert bzgl. Minimum und Maximum    */
  for (i=0; i<S_RES_MAX; i++) {
      begin=(int)( (float)(Z_RES_MAX)*(-min)/max );

      ende =(int)( (float)(Z_RES_MAX*(Histogramm_Werte[i*Anzahl/S_RES_MAX]-min))/max);

      if (begin<ende) {
         for (j=begin; j<ende; j++)
             Pictures[Index+(Z_RES_MAX-j-1)*S_RES_MAX + ((i+Shift) % S_RES_MAX)] = WEISS;
      }
      else {
         for (j=begin; j>ende; j--)
             Pictures[Index+(Z_RES_MAX-j-1)*S_RES_MAX + ((i+Shift) % S_RES_MAX)] = WEISS;
      }
  }

  /* Jetzt die Bildinformation fuer das neue Bild korrekt setzen            */
  Bild[BildNr].Zeilen =Z_RES_MAX;
  Bild[BildNr].Spalten=S_RES_MAX;
  Bild[BildNr].Used   =TRUE;
  Bild[BildNr].Color  =FALSE;

  Make_Icon(BildNr);

}
