/*****************************************************************************
*                                                                            *
* void      Init_Var()                                                       *
*                                                                            *
******************************************************************************
*                                                                            *
* Initialisiert alle globalen Variablen und Felder.                          *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 30.09.1992                                               *
* Letzte Aenderung: 19.12.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: WriteText()                                                    *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Init_Var(void)              /* Initialisierung der globalen Variablen  */
{
  long Index;                    /* Zeiger ueber alle Bildpunkte            */
  int z, s;                      /* Zeilen- und Spaltenzaehler fuer Icons   */

  clrscr();                      /* Bildschirm loeschen                     */

  /* Platz fuer benoetigte Bilder reservieren. Falls erfolglos, dann Abbruch*/
  Pictures=farmalloc((long) (PIC_SIZE*MAX_PICTURE));
  if (Pictures == NULL) {
     WriteText(NO_CURS_POS, NO_CURS_POS, "Bilder konnten nicht angelegt werden. Abbruch!");
     exit(1);
  }

  /* Falls zu wenig freier Hauptspeicher fuer weitere Arbeiten, Abbruch.    */
  if (farcoreleft()<1.5*PIC_SIZE) {
     WriteText(NO_CURS_POS, NO_CURS_POS, "Zu wenig freier Hauptspeicher. Abbruch!");
     exit(1);
  }

  /* Alle Bildpunkte aller Bilder mit Schwarz initialisieren.               */
  for (Index=0; Index<(PIC_SIZE*MAX_PICTURE); Index++)
      Pictures[Index]=SCHWARZ;

  /* Alle Bildinformationen zuruecksetzen, Bilder auf SCHWARZ initialisieren*/
  for (Index=0; Index<MAX_PICTURE; Index++) {
      Bild[Index].Zeilen =0;
      Bild[Index].Spalten=0;
      Bild[Index].Used   =FALSE;
      Bild[Index].Color  =FALSE;
      for (z=0; z<ICON_SIZE; z++)
          for (s=0; s<ICON_SIZE; s++)
              Bild[Index].Icon[z][s]=SCHWARZ;
  }

  directvideo=FALSE;     /* erlaubt Textausgabe ueber BIOS im Graphik-Modus */

}
