/*****************************************************************************
*                                                                            *
* void      Mittelpunkt()                                                    *
*                                                                            *
******************************************************************************
*                                                                            *
* Zeigt ein einzelnens Bild zentriert auf dem Bildschirm an.                 *
* Auf Wunsch kann ein schwarzes Gitter darueber gelegt werden. Beim          *
* Abphotographieren vom Bildschirm sind somit die geringsten Verzerrungen.   *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 23.10.1992                                               *
* Letzte Aenderung: 12.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(), Show_Pic()         *
*             Read_Char(), Show_Icon(), Upper(), PlotPixel()                 *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"

#define  VGA_HORIZ  640
#define  VGA_VERTI  480


void Mittelpunkt()
{
  long z, s;                                  /* Zeilen- und Spaltenzaehler */
  int BildNr;                                 /* Nummer des anzuzeigenden B.*/
  int Gitter_Horizont, Gitter_Vertikal;       /* Groesse des Gitterrasters  */
  unsigned char Color;                        /* geklippter Grauwertindex   */
  long Index, S_PositionOffset, Z_PositionOffset;  /* Offset fuer Zentrier. */
  char Antwort;


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Bild zentriert anzeigen *");

  gotoxy(35,20);
  BildNr=Read_Int("Bild Nr. ", 1, ':');
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr<=0) || (BildNr>MAX_PICTURE)) return;
  BildNr--;                           /* die Zaehlung faengt immer bei 0 an */

  gotoxy(35,21);
  Antwort=Upper(Read_Char("Mit Gitter (J/N) ", 'J'));

  if (Antwort == 'J') {
     gotoxy(35,22);
     Gitter_Horizont=Read_Int("Gitterraster horizontal ", 10, ':');
     gotoxy(35,23);
     Gitter_Vertikal=Read_Int("Gitterraster vertikal   ", 10, ':');

     /* Kontrolle, ob korrekte Werte eingegeben, sonst kein Gitter          */
     if ( (Gitter_Horizont<2) || (Gitter_Horizont>Bild[BildNr].Zeilen) ||
          (Gitter_Vertikal<2) || (Gitter_Vertikal>Bild[BildNr].Spalten) )
        Antwort='N';
  }

  Index = (long) (BildNr) * PIC_SIZE;   /* Anfangsadresse des Bildes        */

  /* Bildschirm zuerst komplett mit SCHWARZ loeschen                        */
  for (z=0; z<VGA_VERTI; z++)
      for (s=0; s<VGA_HORIZ; s++)
          PlotPixel(s, z, SCHWARZ);

  /* Aufloesung-Modus 640x480 Bildpunkte --- Linke obere Ecke ermitteln     */
  S_PositionOffset = (VGA_HORIZ - Bild[BildNr].Spalten) / 2 - 5;
  Z_PositionOffset = (VGA_VERTI - Bild[BildNr].Zeilen ) / 2 - 5;

  /* Bild ausgeben --- vergleiche SHOW_PIC.C                                */
  for (z=0; z<(long)Bild[BildNr].Zeilen; z++) {
      Index = z*(long)Bild[BildNr].Spalten + (long)BildNr*(long)PIC_SIZE;
       for (s=0; s<(long)Bild[BildNr].Spalten; s++) {
           Color = Pictures[Index+s];
           Color = (Color<CLIP_COLOR) ? SCHWARZ:Color;   /* Klipping durchf.*/
           PlotPixel(s+S_PositionOffset, z+Z_PositionOffset, Color);
       }
  }

  /* Gitterraster noch schwarz zeichnen?                                    */
  if (Antwort == 'J') {
     for (z=(-1); z<=(long)Bild[BildNr].Zeilen; z+=Gitter_Horizont)
         for (s=(-1); s<=(long)Bild[BildNr].Spalten; s++) {
             PlotPixel(s+S_PositionOffset, z+Z_PositionOffset, SCHWARZ);
      }
     for (z=(-1); z<=(long)Bild[BildNr].Zeilen; z++)
         for (s=(-1); s<=(long)Bild[BildNr].Spalten; s+=Gitter_Vertikal) {
             PlotPixel(s+S_PositionOffset, z+Z_PositionOffset, SCHWARZ);
      }
  }


  getch();   /* Auf einen beliebigen Tastendruck warten ...                 */

  ClearTextWindow(20, 6,60,23);       /* Mittelpunktbild loeschen und ...   */
  for (s=0; s<MAX_PICTURE; s++) {     /* ... alle benutzen Bilder/Icons ... */
      if (Bild[s].Used) {             /* ... wieder ausgeben.               */
         Show_Pic(s, s+1);
         Show_Icon(s);
      }
  }

}
