/*****************************************************************************
*                                                                            *
* void      Mittelwert(int BildNr1, int BildNr2, int Groesse)                *
*                                                                            *
******************************************************************************
*                                                                            *
* Berechnet den Mittelwert in einem GroessexGroesse-Fenster und setzt den    *
* mittleren Bildpunkt auf diesen Wert.                                       *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 02.11.1992                                               *
* Letzte Aenderung: 12.11.1992                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Input: BildNr1 = Quelbild                                                  *
*        BildNr2 = Zielbild (geglaettetes Bild)                              *
*        Groesse = Groesse des Fensters                                      *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             Make_Icon(), Show_Pic(), Geduld()                              *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Mittelwert(int BildNr1, int BildNr2, int Groesse)
{
  long  z, s, Z_Temp, S_Temp;     /* Variablen fuer Zeilen und Spaltenindex */
  long  Index1, Index2, Index;    /* Adresse der drei Bilder                */
  int   i, j, zwerg;              /* Fenstergroesse und Zwischenergebnis    */
  int   Pixelzahl;                /* Anzahl Pixel im Fenster                */
  long  Zmax, Smax;               /* Bildgroesse                            */


  ClearTextWindow(35,18,80,25);
  WriteText(35,18,"* Glaettung durch Mittelwertfilter *");

  if (!BildNr1) {
     gotoxy(35,20);
     BildNr1=Read_Int("Quell-Bild            ", 1, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr1<=0) || (BildNr1>MAX_PICTURE)) return;
  BildNr1--;                          /* die Zaehlung faengt immer bei 0 an */
  if (!Bild[BildNr1].Used)   return;

  if (!BildNr2) {
     gotoxy(35,21);
     BildNr2=Read_Int("Glaettungs-Bild       ", 2, ':');
  }
  /* Gueltige Bild-Nummer eingegeben?                                       */
  if ((BildNr2<=0) || (BildNr2>MAX_PICTURE)) return;
  BildNr2--;                          /* die Zaehlung faengt immer bei 0 an */

  /* Es sind nur Filter der Groesse 3x3, 5x5 oder 7x7 erlaubt.              */
  while ((Groesse!=3) && (Groesse!=5) && (Groesse!=7)) {
     gotoxy(35,22);
     Groesse=Read_Int("Filtergroesse (3,5,7) ", 3, ':');
  }
  Pixelzahl=Groesse*Groesse;          /* Anzahl Pixel im Filterfenster      */
  Groesse=(int)(Groesse/2);           /* Fenster von  -Groesse...+Groesse   */

  Index1 = (long) (BildNr1) * PIC_SIZE; /* Adresse der beiden Bilder        */
  Index2 = (long) (BildNr2) * PIC_SIZE;

  Zmax = Bild[BildNr1].Zeilen;     /* Groesse des zu bearbeitenden Bildes   */
  Smax = Bild[BildNr1].Spalten;

  Geduld();                        /* Da es lange dauert eine kurze Meldung */

  for (z=0; z<Zmax; z++) {
      for (s=0; s<Smax; s++) {
          zwerg=0;                 /* Summe der Grauwerte im Fenster        */
          for (i= -Groesse; i<=Groesse; i++) {       /* Filtergroesse Zeile */
              Z_Temp=z+i;
              if (Z_Temp<0) Z_Temp= -Z_Temp-1;       /* Klipping am Rand!   */
              else if (Z_Temp>=Zmax) Z_Temp=z-i+1;
              Z_Temp=Z_Temp*Smax;
              for (j= -Groesse; j<=Groesse; j++) {   /* Filtergroesse Spalte*/
                  S_Temp=s+j;
                  if (S_Temp<0) S_Temp= -S_Temp-1;   /* Klipping am Rand!   */
                  else if (S_Temp>=Smax) S_Temp=s-j+1;
                  Index=Index1+Z_Temp+S_Temp;
                  zwerg += Pictures[Index];          /* Werte aufsummieren..*/
              }
          }
          Pictures[Index2++]=(int)(zwerg/Pixelzahl); /* ... und Mittelwert. */
      }
  }

  /* Bildinformation zum Schluss korrekt setzen und ...                     */
  Bild[BildNr2].Zeilen =Zmax;
  Bild[BildNr2].Spalten=Smax;
  Bild[BildNr2].Used   =TRUE;
  Bild[BildNr2].Color  =FALSE;

  /* ... Ergebnisbild anzeigen.                                             */
  Make_Icon(BildNr2);
  Show_Pic(BildNr2, BildNr2+1);
}
