/*****************************************************************************
*                                                                            *
* void      Transform_Menue()                                                *
*                                                                            *
******************************************************************************
*                                                                            *
* Untermenue zur Freuqenztransformation.                                     *
*                                                                            *
******************************************************************************
*                                                                            *
* Erstellungsdatum: 06.11.1992                                               *
* Letzte Aenderung: 16.03.1993                                               *
*                                                                            *
******************************************************************************
*                                                                            *
* Aufruf von: ClearTextWindow(), WriteText(), Read_Int(),                    *
*             DFT_1Dim(), FFT(), Hadamard()                                  *
*                                                                            *
*****************************************************************************/

#include "const.h"

#include "prototyp.h"


void Transform_Menue()
{
  int Auswahl;

  /*---------------------------- Untermenue anzeigen -----------------------*/
  Auswahl = 1;
  while ((Auswahl>0) && (Auswahl<=8)) {
        ClearTextWindow(35,18,80,25);
        WriteText(35,18,">> Bildtransformationen-Frequenzbereich <<");
        WriteText(35,20,"(1)  Zeilen-DFT                             ");
        WriteText(35,21,"(2)  Spalten-DFT                            ");
        WriteText(35,22,"(3)  Fast-Fourier     (7)  DCT");
        WriteText(35,23,"(4)  FFT-Bandpass     (8)  DCT-Filterung");
        gotoxy(35,25);
        Auswahl=Read_Int("Bitte Auswahl angeben (0=Ruecksprung) ", 1, ':');

        switch (Auswahl) {
           case 1:
               /*------- Diskrete Fourier-Transformation einer Zeile -------*/
               DFT_1Dim(TRUE, -1);
               break;
           case 2:
               /*------- Diskrete Fourier-Transformation einer Spalte ------*/
               DFT_1Dim(FALSE, -1);
               break;
           case 3:
               /*------- Fast-Fourier-Transformation ohne Filterung --------*/
               FFT(FALSE);
               break;
           case 4:
               /*------- Fast-Fourier-Transformation mit Filterung ---------*/
               FFT(TRUE);
               break;
           case 5:
               /*--------- Hadamard-Transformation ohne Filterung ----------*/
               break;
           case 6:
               /*--------- Hadamard-Transformation mit Filterung -----------*/
               break;
           case 7:
               /*------ Diskrete-Cosinus-Transformation ohne Filterung -----*/
               DCT(FALSE);
               break;
           case 8:
               /*------ Diskrete-Cosinus-Transformation mit Filterung ------*/
               DCT(TRUE);
               break;
        } /* switch */
  }

}
